#!/usr/bin/perl
use Getopt::Std;
getopts('i:o:t:');

$input=$opt_i;
$output=$opt_o;
$thres=$opt_t;


if($opt_i eq '')
{
    print "USAGE: hemopimod.pl -i <FILE List> -o <output file name> -t <threshold>\n\n";
    print "Example Command: ./hemopimod.pl -i file_list -o out -t 0.5\n\n";
    print "-i\tinput_file_list\n";
    print "-o\toutput_file\n";
    print "-t\tthreshold value\n";
    exit();
}



$file=$input;
print $file;
$prog_path="/gpsr/standalone/hemopimod/prog";
$modeldir = "/gpsr/models/hemopimod";
$ran=int(rand(10000));
$dir="/gpsr/temp/hemopimod_$ran";

#open(FR,">>$output");
#print FR "Prediction\tPredicted Score\n";

`mkdir "$dir"`;

system "/gpsr/local/babel/bin/babel -ipdb $file -osdf $file.sdf";
system "mv $file.sdf $dir/";
system "/gpsr/software/java/bin/java -jar /gpsr/software/padel/PaDEL-Descriptor.jar -fingerprints -descriptortypes $prog_path/descriptors.xml -dir $file.sdf -file $dir/desc >/dev/null";
`grep -v "Name" $dir/desc |perl -pe 's/,/\t/,g' |cut -f2- |perl -pe 's/\t/,/,g' >$dir/feature`;
system "/gpsr/local/bin/perl $prog_path/col2svm.pl -i $dir/feature -o $dir/out -s 0";
system "/gpsr/local/anaconda/bin/python3 $prog_path/model.py $dir/out $dir/out_rf $modeldir/scikit_model/binary_rf_model";
system "/gpsr/local/bin/Rscript $prog_path/round1.R $dir/out_rf $dir/out_rf1";
system "cut -f2 -d' ' $dir/out_svm1|tail -n+2  >  $dir/rounded_out";
system "/gpsr/local/anaconda/bin/python $prog_path/determine.py $dir/rounded_out $thres $dir/pred_res";
system "paste -d ' ' $dir/pred_res $dir/rounded_out >$dir/final_result.csv";
open(FR,">>$output");
print FR "Prediction\tPredicted Score\n";
print FR "final_result.csv\n";
`rm -r $dir/*`;
